var base = {
    options:{
        myScroll:"",
        isgetbind : false,
        bindInfo:{},
        isBind:false,
        onPlayNum:0,//已点曲目
        upSongInfo:{},//顶歌歌曲信息
        nextSongName:"您还没有绑定包厢",
        bindTip:['请扫描点歌台上的二维码来继续操作','绑定码错误，请扫描点歌台上的二维码来继续操作'],
        isMore:["已经到底啦","上滑加载更多","正在努力准备数据，请稍等","数据获取失败，请点击重新获取","暂无相应的数据","输入搜索内容首字母即可查询哦",""],
    },

    init:function(callback){
        // KmApi.enableDebugMode();
        window.addEventListener( "load", function() {
            FastClick.attach( document.body);
        }, false );

        document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);//兼容部分安卓机页面无法滚动的问题
        var _this = this;
        _this.returnPage();
        _this.refreshPage();
        _this.goPage();
        _this.clickMore();
        _this.kmApiReady(callback);
    },

    initBaseInfo: function(callback){
        var _this = this,
            _options = this.options;

        if(_options.isgetbind){
            callback();
            return false;
        }
        //获取包厢信息
        KmApi.getRoomInfo(function(rs){
           // alert(JSON.stringify(rs));
            if(rs.result == 0){
                _this.options.isgetbind = true;
                _this.options.isBind = true;
                _this.options.bindInfo = rs;
            }
            if(typeof callback ==="function"){
                callback();
            }
        });
    },

    kmApiReady:function(callback){
        var _this = this;
        kmDialog.loading();
        KmApi.ready(function(api){
            kmDialog.hideLoading();
            multilingual.init(function(){
                _this.translateTip();
            });
            _this.setPageTopBg();
            _this.initBaseInfo(callback);
        });
    },

    //转译提示语
    translateTip:function(){
        var _this = this;

        for(i=0;i<_this.options.isMore.length;i++){
            _this.options.isMore[i] = multilingual.tranLang(_this.options.isMore[i]);
        }
    },

    //设置页面顶部颜色
    setPageTopBg:function(){
        var url = window.location.href;
        if(url.indexOf("ctrpage.html")!=-1){
            KmApi.iOSSafeAreaSetting({bgcolortop:'FF403B4E',titlestyle:'light'});
        }else{
            KmApi.iOSSafeAreaSetting({bgcolortop:'FFFF6B00',titlestyle:'light'});
        }
    },

    //获取已点歌曲
    getOnPlayList:function(type,pageNum,callback){//type为1为已点页面的请求;2为其它
        var _this = this;
        eProtocolOpt.sendE402(pageNum,15,'',function(error,message,data){
            // var result = JSON.stringify(data);
            // alert("已点歌曲error:"+error+" message:"+message+" data:"+result);
            if(error==0 && type==2){
                $('.ctl-page .music').removeClass('active');
                if(data.records.totalnum==0){
                    _this.options.nextSongName = "没有歌啦，快去点两首吧";
                }else if(data.records.totalnum==1){
                    _this.options.nextSongName = "没有下一首啦，快去点歌吧";
                }else{
                    $('.ctl-page .music').addClass('active');
                   _this.options.nextSongName = "<span langext='more'>下一首</span>："+data.records.record[1]['songname'];
                }
                base.options.onPlayNum = data.records.totalnum;
                $('.onplay-num').html(base.options.onPlayNum);
                $('.next-name').html(base.options.nextSongName);
                multilingual.refreshLang();
            }
            if(typeof callback ==="function"){
                callback(error,message,data);
            }
        });
    },

    //加载失败或是手动加载更多
    clickMore:function(){
        var _this = this;

        $('.more-tip').click(function(){
            var isMore = $(this).attr('data-ismore'),
                method = $(this).attr('data-method'),
                key = $(this).attr('data-key');

            if(isMore!=1 && isMore!=3){//1为查看更多;3为获取失败，重新获取
                return false;
            }
            switch(method){
                case "getAlbumData"://歌单页面
                    albumList.getAlbum();
                    break;
                case "getSingerListByType"://歌手页
                    singerList.getSingerListByType();
                    break;
                case "getSongData"://歌曲页
                    songList.getSongData();
                    break;
                case "getOnPlayData"://已点页
                    onPlay.getOnPlayData();
                    break;
                case "getSongData"://已唱页
                    sungSong.getSongData();
                    break;
                case "getSingerAndSongBySearchKey"://搜索页面的搜索按钮
                    searchPage.getSingerAndSongBySearchKey();
                    break;
                default:
                    console.log('method:'+method);
            }
        })
    },

    //点歌按钮
    songBtn:function(){
        var _this = this;
        //显示置顶按钮
        $('.song-list').on('click','.show-info',function(){
            var songKp = $(this).attr('data-songkp');
            if(songKp==13 || songKp==14){//云歌曲不显示置顶按钮
                return false;
            }
            if($(this).hasClass('active')){
                $(this).removeClass('active');
            }else{
                $('.song-list .show-info').removeClass('active');
                $(this).addClass('active');
            }
        })

        //置顶
        $('.song-list').on('click','.top-song',function(){
            if(!_this.options.isBind){
                _this.showBindTip(0);
                return false;
            }
            var obj = $(this);
            _this.upSong(obj,function(){
                $('.song-list .show-info').removeClass('active');
                base.getOnPlayList(2,1);
            });
        })

        //点歌
        $('.song-list').on('click','.list-btn',function(e){
            e.stopPropagation();
            $('.song-list .show-info').removeClass('active');
            if(!_this.options.isBind){
                _this.showBindTip(0);
                return false;
            }
            var obj = $(this);
            _this.playSong(obj)
        })
    },

    //点歌
    playSong:function(obj,callback){
        var _this = this,
            songinfo = {
            songid : obj.attr('data-songid'),
            songname : obj.attr('data-songname'),
            singername : obj.attr('data-singername'),
            songkp : obj.attr('data-songkp'),
            isexist : 1
        };
        kmDialog.loading();
        eProtocolOpt.playSongByE400(songinfo,function(error,message,data){
            kmDialog.hideLoading();
            // var result = JSON.stringify(data);
            // alert("error:"+error+" message:"+message+" data:"+result);
            if(error==0 || error==118){
                kmDialog.toast("成功");
                _this.options.onPlayNum = parseInt(_this.options.onPlayNum)+1;
                $('.onplay-num').html(_this.options.onPlayNum);
            }else if(error==1){
                kmDialog.toast("已经点过了");
            }else if(error==199 || error==1199){
                _this.unBindRoom(function(){
                    _this.showBindTip(1);
                });
            }else{
                kmDialog.toast(message);
            }
        });
    },

    //顶歌
    upSong:function(obj,callback){
        var _this = this,
            songInfo = {
                songid : obj.attr('data-songid'),
                songkp : obj.attr('data-songkp')
            };
        kmDialog.loading();
        eProtocolOpt.playUpSongByE400(songInfo,function(error,message,data){
            kmDialog.hideLoading();
            // var result = JSON.stringify(data);
            // alert("error:"+error+" message:"+message+" data:"+result);
            if(error==0){
                kmDialog.toast("成功");
                if(typeof callback ==="function"){
                    callback();
                }
            }else if(error==199 || error==1199){
                _this.unBindRoom(function(){
                    _this.showBindTip(1);
                });
            }else{
                kmDialog.toast(message);
            }
        });
    },

    //获取专辑列表
    getAlbumList:function(pageIndex,pageLength,callback){
     
        dProtocolOpt.getD330(pageIndex,pageLength,function(error,message,data){
            // var result = JSON.stringify(data);
            // alert("专辑新:"+result);
            callback(error,message,data);
        });
    },

    //绑定弹框提示
    showBindTip:function(type){//0为直接扫描;1为199绑定码错误
        var _this = this;
        kmDialog.confirm(_this.options.bindTip[type],function(){
            KmApi.webToAppBindKtv(function(rs){
                if(rs.result!=-1){
                    kmDialog.toast("绑定成功");
                   // window.location.href = location.pathname+"?v="+ Math.round(Math.random()*9+1);
                    window.location.reload();
                }else{
                    kmDialog.toast("绑定失败");
                }
            });
        });
    },

    //解绑操作
    unBindRoom:function(callback){
        dProtocolOpt.notifyUnbind();
        eProtocolOpt.notifyUnbind();
        KmApi.webToAppUnbindKtv(function(rs){
            if(rs.result==0){//解绑成功
                if(typeof callback ==="function"){
                    callback();
                }
            }
        })
    },

    //进入新页面
    goPage:function(){
        $('.function-box .go-page,.page-top .onplay-btn,.remote-ctl').click(function(event) {
            var url = $(this).attr('data-url');
            if($(this).hasClass('remote-ctl')){
                $('.on-play').html("").attr('data-page',1);//已经点页面
                window.location.href =  url;
                return false
            }
            if(base.options.isBind){
               window.location.href =  url;
            }else{
                base.showBindTip(0);
            }
        })
    },

    //页面返回
    returnPage:function(){
        $('.return-btn,.ctl-page .wrapper-footer').click(function(event) {
            window.history.go(-1);
        });
    },

    //刷新页面
    refreshPage:function(){
        $('.refresh-page').click(function(){
            window.location.reload();
        })
    },

    scrollPage:function(callback){
        var _this = this;
        _this.options.myScroll = new IScroll('.wrapper-content',{});
        if(typeof callback==="function"){
            _this.options.myScroll.on('scrollEnd', function () {
                callback();
            })
        }
    },

    freshScoll:function(pageNum){
        var _this = this;
        setTimeout(function(){
            _this.options.myScroll.refresh();
        },500)
    },

    //获取url中的参数
    getUrlParam: function(name){
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var r = window.location.search.substr(1).match(reg);  //匹配目标参数
        if (r != null) return decodeURI(r[2]); return ''; //返回参数值
    }
}
