var eProtocolOpt = {

	option : {
		bindstatus : false,
	},

	/**
	 *解绑通知
	 */
	notifyUnbind : function(){
		var _this = this,
		    _option = this.option;

		_option.bindstatus = false;
	},

	/**
	 *已点
	 */
	sendE402 : function(pagenum,pagelength,type,callback){
		var _this = this;
		pagenum = pagenum || 1;
		pagelength = pagelength || 20;
		type = type || '';
		var startpos = (pagenum-1)*pagelength;
		var num = pagelength;

		_this._initBefore(callback,function(){
			var cmdid = "E402";
			var extrastr = "<records startpos='"+startpos+"' num='"+num+"' timestamp='0' type='"+type+"' />";
			var xmlstr = _this._buildProtocol(cmdid,"",extrastr);

			_this._parseProtocol(xmlstr,function(error,message,data){
				if(error == 0 && typeof data.records !== "undefined"){
					var length = (typeof data.records.recordsnum === "undefined")?0:data.records.recordsnum;
					var total = (typeof data.records.totalnum === "undefined")?0:data.records.totalnum;
					if(length == 1){
						data.records.record = [data.records.record];
					}
					data.records.more = ((Number(pagelength) > Number(length)) || (Number(pagelength)*Number(pagenum)) == Number(total))?'0':'1'; //是否还有更多 1有 0没有
				}
	        	if(typeof callback === "function"){ callback(error,message,data); }
			});
		});
	},

	/**
	 *已唱
	 */
	sendE412 : function(pagenum,pagelength,type,callback){
	 	var _this = this;
		pagenum = pagenum || 1;
		pagelength = pagelength || 20;
		type = type || '';
		var startpos = (pagenum-1)*pagelength;
		var num = pagelength;

		_this._initBefore(callback,function(){
			var cmdid = "E412";
			var extrastr = "<records startpos='"+startpos+"' num='"+num+"' timestamp='0' type='"+type+"' />";
			var xmlstr = _this._buildProtocol(cmdid,"",extrastr);

			_this._parseProtocol(xmlstr,function(error,message,data){
				if(error == 0 && typeof data.records !== "undefined"){
					var length = (typeof data.records.recordsnum === "undefined")?0:data.records.recordsnum;
					var total = (typeof data.records.totalnum === "undefined")?0:data.records.totalnum;
					if(length == 1){
						data.records.record = [data.records.record];
					}
					data.records.more = ((Number(pagelength) > Number(length)) || (Number(pagelength)*Number(pagenum)) == Number(total))?'0':'1'; //是否还有更多 1有 0没有
				}
	        	if(typeof callback === "function"){ callback(error,message,data); }
			});
		});
	},

	/**
	 *点歌
	 */
	playSongByE400 : function(songinfo,callback){
		var _this = this;

		var songid = (typeof songinfo.songid === "undefined")?"":songinfo.songid;
		var songname = (typeof songinfo.songname === "undefined")?"":songinfo.songname;
		var singername = (typeof songinfo.singername === "undefined")?"":songinfo.singername;
		var songkp = (typeof songinfo.songkp === "undefined")?"":songinfo.songkp;
		var isexist = (typeof songinfo.isexist === "undefined")?"":songinfo.isexist;

		songname = _this._specialSymbolsEscape(songname);
		singername = _this._specialSymbolsEscape(singername);

		var objinfo = {
			controltype : 40,
			controlvalue : songid,
			kp : songkp
		};
		var extrastr = "";
		if(isexist == 1){
			extrastr = "<records><record songname='"+songname+"' singername='"+singername+"' /></records>"; 
		}

		_this._buildE400(objinfo,extrastr,function(error,message,data){
        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	},

	/**
	 *顶歌
	 */
	playUpSongByE400 : function(songinfo,callback){
		var _this = this;

		var songid = (typeof songinfo.songid === "undefined")?"":songinfo.songid;
		var songkp = (typeof songinfo.songkp === "undefined")?"":songinfo.songkp;

		var objinfo = {
			controltype : 41,
			controlvalue : songid,
			kp : songkp
		};

		_this._buildE400(objinfo,"",function(error,message,data){
        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	},

	/**
	 *播控
	 */
	playControllByE400 : function(type,callback){
		var _this = this;

		var type_arr = new Array();
		type_arr[101] = new Array(10,1);//播放、暂停
		type_arr[102] = new Array(10,2);//切歌
		type_arr[103] = new Array(10,3);//重唱
		type_arr[104] = new Array(10,4);//原唱、伴唱
		type_arr[201] = new Array(20,1);//麦克风音量加
		type_arr[202] = new Array(20,2);//麦克风音量减
		type_arr[203] = new Array(20,3);//音乐音量加
		type_arr[204] = new Array(20,4);//音乐音量减
		type_arr[221] = new Array(22,1);//喝彩
		type_arr[222] = new Array(22,2);//倒彩

		if(typeof type_arr[type] === "undefined"){
        	if(typeof callback === "function"){ callback(-97,"命令错误",{}); }
			return false;
		}

		var objinfo = {
			controltype : type_arr[type][0],
			controlvalue : type_arr[type][1]
		};

		_this._buildE400(objinfo,"",function(error,message,data){
        	if(typeof callback === "function"){ callback(error,message,data); }
		});
	},

	/**
	 *服务操作
	 */
	sendE000 : function(status,callback){
		var _this = this;
		status = (status==1)?"false":"true"; //1为取消服务 其它为呼叫服务

		_this._initBefore(callback,function(){
			var cmdid = "E000";
			var bodystr = "msgid='851' status='"+status+"'";
			var xmlstr = _this._buildProtocol(cmdid,bodystr,"");

			_this._parseProtocol(xmlstr,function(error,message,data){
	        	if(typeof callback === "function"){ callback(error,message,data); }
			});
		});
	},

	/**
	 *E400协议通用封装
	 */
	_buildE400 : function(objinfo,extrastr,callback){
		var _this = this;

		_this._initBefore(callback,function(){
			var cmdid = "E400";
			var controltype = (typeof objinfo.controltype === "undefined")?"":"controltype='"+objinfo.controltype+"' ";
			var controlvalue = (typeof objinfo.controlvalue === "undefined")?"":"controlvalue='"+objinfo.controlvalue+"' ";
			var kp = (typeof objinfo.kp === "undefined")?"":"kp='"+objinfo.kp+"' ";

			var bodystr = controltype+controlvalue+kp;
			var xmlstr = _this._buildProtocol(cmdid,bodystr,extrastr);

			_this._parseProtocol(xmlstr,function(error,message,data){
	        	if(typeof callback === "function"){ callback(error,message,data); }
			});
		});
	},

	_initBefore : function(callback,callfun){
		var _this = this;
		var _option = this.option;

		_this._getBindInfo(function(){
			if(!_option.bindstatus){
				if(typeof callback === "function"){ callback(1199,"请先绑定包厢！",{}); }
				return false;
			}

			callfun();
		});
	},

	_getBindInfo : function(callback){
		var _this = this;
		var _option = this.option;

		if(_option.bindstatus){
			callback();
			return false;
		}

		KmApi.getRoomInfo(function(result){
			if(result.result == 0){ //有绑定
				_option.bindstatus = true;
			}
			callback();
		});
	},

	/**
	 * 特殊符号转义
	 */
	_specialSymbolsEscape : function(str){
		str = str.replace(/\'/g, "&apos;");
		str = str.replace(/\"/g, "&quot;");
		str = str.replace(/\>/g, "&gt;");
		str = str.replace(/\</g, "&lt;");
		return str;
	},

	/**
	 * 转回特殊字符串
	 */
	_specialSymbolsBack : function(str){
		str = str.replace(/&apos;/g, "\'");
		str = str.replace(/&quot;/g, "\"");
		str = str.replace(/&gt;/g, "\>");
		str = str.replace(/&lt;/g, "\<");
		return str;
	},

	/**
	  *协议组包
	  */
	_buildProtocol : function(cmdid,bodystr,extrastr){
		var _this = this;

		cmdid = cmdid || '';
		bodystr = bodystr || '';
		extrastr = extrastr || '';

		bodystr = bodystr.replace(/\'/g, "\"");
		extrastr = extrastr.replace(/\'/g, "\"");
		// bodystr = _this._specialSymbolsBack(bodystr);
		// extrastr = _this._specialSymbolsBack(extrastr);

		var xmlstr = '<message><head /><body cmdid="'+cmdid+'" '+bodystr+'>'+extrastr+'</body></message>';
		return xmlstr;
	},

	/**
	 *协议解析
	 */
	_parseProtocol : function(xmlstr,callback){
		var _this = this;
		KmApi.eProtocol({xml:xmlstr},function(rs){
        	var error = (typeof rs.data.result === "undefined")?-99:rs.data.result;
        	var message = (typeof rs.data.resultmsg === "undefined")?'协议发送失败[app]':rs.data.resultmsg;
        	var dataxmlstr = (typeof rs.data.xml === "undefined")?'':rs.data.xml;

        	var data = {};
        	if(error == 0 && dataxmlstr.length > 0){
        		var xmljson = _this._xmlStrToObj(dataxmlstr);
        		var xmldata = _this._xmlObjToJson(xmljson);

        		var susmsg = (typeof xmldata.message.body.susmsg === "undefined")?'':xmldata.message.body.susmsg;
        		var errormessage = (typeof xmldata.message.body.errormessage === "undefined")?'解析失败[vod]':xmldata.message.body.errormessage;

        		error = (typeof xmldata.message.body.errorcode === "undefined")?-98:xmldata.message.body.errorcode;
        		message = (susmsg.length > 0)?susmsg:errormessage;
        		data = (typeof xmldata.message.body === "undefined")?{}:xmldata.message.body;
        	}

        	if(typeof callback === "function"){ callback(error,message,data); }
        });
	},

	/**
	 *xml字符串转xml对象
	 */
	_xmlStrToObj : function(xmlStr){
		var _this = this;
		var str = xmlStr;
	  	if(str == null){
	   		return null;
	  	}
	  	var doc = str;
	  	try{
	   		doc = createXMLDOM();
	   		doc.async = false;
	   		doc.loadXML(str);
	  	}catch(e){
	   		doc = $.parseXML(str);
	  	}
	  	return doc;
	},

	/**
	 *xml对象转json格式
	 */
	_xmlObjToJson : function(xmlObj){
		var _this = this;
		var xml = xmlObj;
		// Create the return object 
		var obj = {};
		if(xml.nodeType == 1){ // element 
			// do attributes 
			if (xml.attributes.length > 0) { 
				// obj["attributes"] = {}; 
				for(var j = 0; j < xml.attributes.length; j++){ 
					var attribute = xml.attributes.item(j); 
					// obj["attributes"][attribute.nodeName] = attribute.nodeValue; 
					obj[attribute.nodeName] = attribute.nodeValue; 
				} 
			} 
		}else if(xml.nodeType == 3){ // text 
			obj = xml.nodeValue;
		}
		// do children 
		if(xml.hasChildNodes()){ 
			for(var i = 0; i < xml.childNodes.length; i++){ 
				var item = xml.childNodes.item(i); 
				var nodeName = item.nodeName; 
				if(typeof (obj[nodeName]) == "undefined"){ 
					obj[nodeName] = _this._xmlObjToJson(item); 
				}else{ 
					if(typeof (obj[nodeName].length) == "undefined"){ 
						var old = obj[nodeName]; 
						obj[nodeName] = []; 
						obj[nodeName].push(old); 
					}
					obj[nodeName].push(_this._xmlObjToJson(item)); 
				}
			} 
		} 
		return obj; 
	}

}
