var multilingual = {

	option : {
		status : false, //是否已请求过语言接口
		lang : 'zh_cn'
	},

	init : function(callback){
		var _this = this;

		_this._initLang(function(){
			_this.refreshLang(callback);
		});
	},

	refreshLang : function(callback){
		var _this = this;
		var $ele = _this._getEle();
		$ele.each(function(i){
			var str = $(this).html().trim();
			var result = _this._translation(str);
			if(typeof result === 'string' && result.length > 0){
				$(this).html(result);
			}
		});
	    if(typeof callback === "function"){ callback(); }
	},

	tranLang : function(str){
		var _this = this;
		var result = _this._translation(str);
		return (result.length > 0)?result:str;
	},

	_initLang : function(callback){
		var _this = this;
		var _option = this.option;

		if(_option.status){
			callback();
			return false;
		}

		KmApi.getAppLang(function(rs){
			var lang = (typeof rs.lang === "undefined")?'zh_cn':rs.lang;
			_option.lang = lang;
			_option.status = true;
			callback();
        });
	},

	_getEle : function(){
		return $("[langext='more']");
	},

	_translation : function(str){
		var _this = this;
		var _option = this.option;
		var langPack = _this._getLangPack();
		if(typeof langPack[str] !== 'undefined'){
			var langJson =  langPack[str];
			return (typeof langJson[_option.lang] === "undefined")?'':langJson[_option.lang];
		}
		return '';
	},

	_getLangPack : function(){
		return {
			'歌星、歌曲、简拼' : {
				'zh_tw' : '歌星、歌曲、首拼',
				'en' : 'SINGER,SONG,SPELL'
			},
			'点击扫码连接包厢' : {
				'zh_tw' : '點選掃描連接包廂',
				'en' : 'Scan Qr Code Enjoy Moblie Vod'
			},
			'歌手' : {
				'zh_tw' : '歌手',
				"en" : 'SINGER'
			},
			'歌单' : {
				'zh_tw' : '歌單',
				'en' : 'SONG LIST'
			},
			'已点' : {
				'zh_tw' : '已點',
				'en' : 'SELECTED'
			},
			'已唱' : {
				'zh_tw' : '已唱',
				'en' : 'SONG SUNG'
			},
			'歌单推荐' : {
				'zh_tw' : '歌曲推薦',
				'en' : 'SONGS RECOMMENDED'
			},
			'原/伴' : {
				'zh_tw' : '原/伴',
				'en' : 'VOCAL/<br>ACCOMPANY'
			},
			'切歌' : {
				'zh_tw' : '切歌',
				'en' : 'NEXT SONG'
			},
			'播/停' : {
				'zh_tw' : '播/停',
				'en' : 'PLAY/PAUSE'
			},
			'重唱' : {
				'zh_tw' : '重唱',
				'en' : 'REPLAY'
			},
			'麦克风音量' : {
				'zh_tw' : '麥克風音量',
				'en' : 'MIC VOL'
			},
			'音乐音量' : {
				'zh_tw' : '音樂音量',
				'en' : 'MUSIC VOL'
			},
			'喝彩' : {
				'zh_tw' : '喝采',
				'en' : 'APPLAUSE'
			},
			'倒彩' : {
				'zh_tw' : '倒采',
				'en' : 'TAUNT'
			},
			'服务铃' : {
				'zh_tw' : '服務鈴',
				'en' : 'SERVICE BELL'
			},
			'您还没有绑定包厢' : {
				'zh_tw' : '尚未綁定包廂',
				'en' : "You haven't connected device"
			},
			'热门' : {
				'zh_tw' : '熱門',
				'en' : 'HIT/POP'
			},
			'取消' : {
				'zh_tw' : '取消',
				'en' : 'CANCEL'
			},
			'确定' : {
				'zh_tw' : '確定',
				'en' : 'OK'
			},
			'精选歌单' : {
				'zh_tw' : '精選歌曲',
				'en' : 'FEATURED SONGS'
			},
			'在播' : {
				'zh_tw' : '在播',
				'en' : 'PLAYING'
			},
			'置顶' : {
				'zh_tw' : '置頂',
				'en' : 'TOP'
			},
			'请扫描点歌台上的二维码来继续操作' : {
				'zh_tw' : '請掃描觸控螢幕上的二維碼',
				'en' : 'Please scan QR Code on touch screen to continue the operation'
			},
			'绑定码错误，请扫描点歌台上的二维码来继续操作' : {
				'zh_tw' : '連線錯誤，請重新再次掃描觸控螢幕的二維碼',
				'en' : 'Binding Code error, Please scan QR Code on touch screen to continue the operation'
			},
			'已经到底啦' : {
				'zh_tw' : '最後一頁',
				'en' : 'Already in the end'
			},
			'上滑加载更多' : {
				'zh_tw' : '上滑更多加載',
				'en' : 'Slide up for more'
			},
			'正在努力准备数据，请稍等' : {
				'zh_tw' : '數據準備中…請稍候',
				'en' : 'We are still trying, Please wait'
			},
			'数据获取失败，请点击重新获取' : {
				'zh_tw' : '數據下載失敗，請點重新下載',
				'en' : 'Failed to acquire data, Please click to retry'
			},
			'暂无相应的数据' : {
				'zh_tw' : '暫無相關的數據',
				'en' : 'No corresponding data'
			},
			'输入搜索内容首字母即可查询哦' : {
				'zh_tw' : '輸入搜尋內容的首字字母可查詢',
				'en' : 'Enter the first letter of each word'
			},
			'没有歌啦，快去点两首吧' : {
				'zh_tw' : '沒有歌了!!請再點歌',
				'en' : 'End of song list , Please pick more songs'
			},
			'没有下一首啦，快去点歌吧' : {
				'zh_tw' : '沒有下一首歌了!!',
				'en' : 'End of song list , Please pick more songs'
			},
			'下一首' : {
				'zh_tw' : '下一首',
				'en' : 'Next'
			},
			'已经点过了' : {
				'zh_tw' : '已經點過了',
				'en' : 'Song has been picked'
			},
			'绑定成功' : {
				'zh_tw' : '連線成功',
				'en' : 'Binding success'
			},
			'绑定失败' : {
				'zh_tw' : '連線失敗',
				'en' : 'Binding failed'
			},
			'已开始重唱该首歌曲' : {
				'zh_tw' : '已開始重唱該首歌曲',
				'en' : 'Song has been replay'
			},
			'已切换到下一首歌曲' : {
				'zh_tw' : '已切換到下一首歌曲',
				'en' : 'Next Song'
			},
			'已呼叫服务员，请稍等' : {
				'zh_tw' : '已通知服務人員，請稍候',
				'en' : 'Service has been called, Please wait'
			},
			'已调大麦克风音效' : {
				'zh_tw' : '麥克風音效-大',
				'en' : 'Big microphone Vol adjusted'
			},
			'已调小麦克风音效' : {
				'zh_tw' : '麥克風音效-小',
				'en' : 'Small microphone Vol adjusted'
			},
			'已调大背景音乐' : {
				'zh_tw' : '背景音樂-大',
				'en' : 'Main background music adjusted'
			},
			'已调小背景音乐' : {
				'zh_tw' : '背景音樂-小',
				'en' : 'Sub background music adjusted'
			},
			'成功' : {
				'zh_tw' : '成功',
				'en' : 'Success'
			},
			'是否需要呼叫服务' : {
				'zh_tw' : '是否需要通知服務人員',
				'en' : 'Do you need to call service'
			},
			'是否切换到下一首歌曲' : {
				'zh_tw' : '確定切換到下一首歌曲',
				'en' : 'Whether to switch to the next song'
			},
			'顶歌' : {
				'zh_tw' : '插播',
				'en' : 'Top this song'
			},
			'来自手机用户' : {
				'zh_tw' : '來自手機用戶',
				'en' : 'From mobile phone user'
			},
			'来自点歌台' : {
				'zh_tw' : '來自觸控螢幕',
				'en' : 'From Vod'
			},
			'请输入搜索关键字' : {
				'zh_tw' : '請輸入要搜尋的關鍵字',
				'en' : 'Please enter your search keywords'
			},
			'切换语言' : {
				'zh_tw' : '切換語言',
				'en' : 'Switch Language'
			},
			'搜索' : {
				'zh_tw' : '搜尋',
				'en' : 'Search'
			},
			'查看更多歌手' : {
				'zh_tw' : '查看更多歌手',
				'en' : 'Search for more singers'
			},
			'搜不到任何东西，换个词试试哈' : {
				'zh_tw' : '搜尋不到條件相符',
				'en' : 'Unable to find, Please try again'
			},
			'K米点歌' : {
				'zh_tw' : 'K米点歌',
				'en' : 'KTVme'
			},
			'K米' : {
				'zh_tw' : 'K米',
				'en' : 'KTVme'
			},
			'下载中' : {
				'zh_tw' : '下載中',
				'en' : 'LOADING'
			},
			'15px' : {
				'zh_tw' : '15px',
				'en' : '0.2666667rem'
			},
			'12px' : {
				'zh_tw' : '12px',
				'en' : '0.16rem'
			}
		}
	},

}

